/* 
 *
 * WARNING ! ADVERTENCIA ! ACHTUNG !  (Friends release)
 *
 * This release is only for friend, i will make this code public, but i just
 * advices, comments, suggestion or whatever of friends, so i can release
 * a nice version to the public. So please, dont spRead out until i release
 * some public version
 *
 * Gracias, Nico y cuc0 y p0
 *
 * felices fiestas!?
 * 
 * .TODO:
 *     - pass just 2 parameters to get_dynamic_tag()
 *     - handle signals and detach from process
 *     - enforce strict ELF header (enable/disable ELFMAG when reading any ELF header)
 *     - use DT_STRSZ to stop dumping SYMTAB instead of heuristic
 *     - Dump process to file (stack, heap, ...)
 *     - add DT_PLTGOT checking file/core (injectso)
 *     - compare dynamic symbol from the process to a file
 *     - -s option
 *     - use Elf32_* types
 *     - see what are undefined entries...
 * 
 * Procshow works as objdump but in a process in real time
 * Using ptrace it attach to the process and get some information like:
 * phdr, dynamic symbols,etc (not only of the program, it also take information
 * from theirs shared objects)
 * Note: I try to make it similar to objdump in order the user get used 
 * easily to procshow, this is why the output and stuff are
 * pretty similar to objdump (but not the code)
 * 
 * Coded by: Nicolas Waisman (zb0@mail.ru) and cuc0@mail.ru
 *
 * NOTE #1: que tetas las de mechi
 *
 * NOTE #2: que tetasssssssss las de mechiiiiiiiiiiiiiiiiiiiii, aceleje!
 * 
 */
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <stdio.h>
#include <unistd.h>
#include <sys/ptrace.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <signal.h>
#ifdef LINUX
#include <linux/limits.h>   
#include <linux/user.h>
#include <asm/unistd.h>
#endif
#include <elf.h>
#ifdef FREEBSD
#include <sys/syslimits.h> /* home of PATH_MAX */
#include <sys/elf_common.h>
#include "rtld.h"
#endif
#include "dl-hash.h"
#include <errno.h>

#ifdef BIG_LINKMAP			// not sure, maybe this makes some trouble
	#include "link.h"			// not TELETUBBIE POWER at link.h
									// #define  DT_THISPROCNUM 40 
#else
	#include <link.h>
#endif
//#include "rtld.h"
//#define STACK_TOP 0xbfffffff			// default linux stack map address
#ifdef LINUX
	#define STACK_TOP   0xc0000100			// we can pass here higher value between OSs
							// find_stack_top() will climb the stack until not receiving 
							// any error
#elif FREEBSD
	#define STACK_TOP 0xbfc00100 
#endif
#define DEFAULT_ALIGN 0x1000

#define START_ADDR 0x8048000
#define ES_ELF(ehdr)    ((ehdr).e_ident[EI_MAG0] == ELFMAG0 && \
                         (ehdr).e_ident[EI_MAG1] == ELFMAG1 && \
                         (ehdr).e_ident[EI_MAG2] == ELFMAG2 && \
                         (ehdr).e_ident[EI_MAG3] == ELFMAG3)


#define UNTIL_ARGV 5 +1 // por las dudas 
enum { WARN_LOWLEVEL, WARN_MEDLEVEL, WARN_HIGLEVEL };

struct _Elf_hash {
	int nbucket;
	int nchain;
	Elf32_Addr symtab;
	Elf32_Addr strtab;
	Elf32_Addr *bucket;
	Elf32_Addr *chain;
};

void dump_symbol(Elf32_Sym *, Elf32_Addr);
char optionc(char *, int, int);
void pattach(void);
void pattach(void);
void pdetach(void);
void pcont(int signal);
void psyscall(int signal);
void usage(char *);
long ppeek(int addr);
char *getStringB(unsigned long addr );
char *getString(unsigned long addr );
size_t pRead(unsigned long src, void *dst, size_t sz);
void fatal(char *format, ...);
//void readmap(void);
//struct dynamic_info  *DynamicInfo(struct link_map *);
unsigned int get_ehdr(unsigned long base, Elf32_Ehdr *ehdr);
unsigned int get_phdr(unsigned long base, size_t sz, Elf32_Phdr **phdr);
void dump_ehdr(Elf32_Ehdr ehdr);
void dump_phdr(Elf32_Phdr *phdr, int e_phnum);
unsigned long get_dynamic(Elf32_Phdr *phdr, int e_phnum);
void dump_dynamic(Elf32_Addr dynamic,Elf32_Addr strtab);
unsigned long get_dynamic_tag(Elf32_Addr dynamic,struct link_map *lm, unsigned int tag);
#ifdef FREEBSD
	void get_link_map(Elf32_Addr address, struct link_map *lm,unsigned char bool);
#else
	void get_link_map(Elf32_Addr address, struct link_map *lm);
#endif
Elf32_Addr get_auxv(Elf32_Addr stack_top);
unsigned long searchWord(unsigned long start, unsigned long stop, unsigned long iwantu);
void dump_auxv(Elf32_Addr auxv);
void pReadChar(unsigned long src, unsigned char *dst);
void dump_argv(Elf32_Addr argv);
void dump_envp(Elf32_Addr envp);
Elf32_Addr get_argv(Elf32_Addr argv_end);
unsigned long get_auxv_entry(Elf32_Addr auxv,unsigned int entry);
unsigned long get_debug(Elf32_Addr address,struct r_debug *rd);
void dump_debug(struct r_debug *rd);
Elf32_Addr find_stack_top(void);
void search_elf(Elf32_Addr start,Elf32_Addr stop);
Elf32_Addr reverse_resolve(char *wanted, struct link_map *lm);  
void free_hash(struct _Elf_hash *);
struct _Elf_hash *get_hash(Elf32_Addr, Elf32_Addr, Elf32_Addr);
void get_symbol(Elf32_Addr addr, Elf32_Sym *);
void dump_reloc(Elf32_Addr reloc,unsigned int relsz,Elf32_Addr symtab,Elf32_Addr strtab);
void *menem(const void *buf, const void *pattern, size_t buflen, size_t len);
/*
/*
 * not using this now, but may be useful in near future
 */
struct dynamic_info {
   Elf32_Addr got;
   Elf32_Addr strtab;
   Elf32_Addr symtab;
   unsigned int strsz;
   unsigned int nchain;
};
