/* 
 *
 * WARNING ! ADVERTENCIA ! ACHTUNG !  (Friends release)
 *
 * This release is only for friend, i will make this code public, but i just
 * advices, comments, suggestion or whatever of friends, so i can release
 * a nice version to the public. So please, dont spRead out until i release
 * some public version
 *
 * Gracias, Nico y cuc0 y p0
 *
 * felices fiestas!?
 * 
 * .TODO:
 * 	 - improve debug_me()
 *     - pass just 2 parameters to get_dynamic_tag()
 *     - handle signals and detach from process
 *     - enforce strict ELF header (enable/disable ELFMAG when reading any ELF header)
 *     - use DT_STRSZ to stop dumping SYMTAB instead of heuristic
 *     - Dump process to file (stack, heap, ...)
 *     - add DT_PLTGOT checking file/core (injectso)
 *     - compare dynamic symbol from the process to a file
 *     - -s option
 *     - use Elf32_* types
 *     - see what are undefined entries...
 * 
 * Procshow works as objdump but in a process in real time
 * Using ptrace it attach to the process and get some information like:
 * phdr, dynamic symbols,etc (not only of the program, it also take information
 * from theirs shared objects)
 * Note: I try to make it similar to objdump in order the user get used 
 * easily to procshow, this is why the output and stuff are
 * pretty similar to objdump (but not the code)
 * 
 * Coded by: Nicolas Waisman (zb0@mail.ru) and cuc0@mail.ru
 *
 * NOTE #1: que tetas las de mechi
 *
 * NOTE #2: que tetasssssssss las de mechiiiiiiiiiiiiiiiiiiiii, aceleje!
 * 
 */

#include "procshow.h"

extern pid_t pid;
extern FILE *out;


#ifdef LINUX
void get_link_map(Elf32_Addr address, struct link_map *lm){
	/* vos creias que era la vida tan facil! INUTIL! */
	pRead(address,lm,sizeof(struct link_map));
}
#elif FREEBSD
void get_link_map(Elf32_Addr address, struct link_map *lm,unsigned char bool){
	long wii;
	Obj_Entry ob;
	if(!bool) {
		pRead(address, &ob, sizeof(Obj_Entry));
		memcpy(lm,& ob.linkmap, sizeof(struct link_map));
		//pRead(ob.link.stqe_next+152 lm, sizeof(struct link_map));
	} else  
		pRead(address,lm,sizeof(struct link_map));
}
#endif

// not using this now, may be useful in near future
struct dynamic_info *get_dynamic_info(struct link_map *lm) {
   Elf32_Dyn dynamic;
   long boo;
   unsigned int dsize=sizeof(Elf32_Dyn);
   long daddr=(long) lm->l_ld;
   struct dynamic_info *info=(struct dynamic_info *)malloc(sizeof(struct dynamic_info));
   
   pRead(daddr, &dynamic, dsize);
   while( dynamic.d_tag != DT_NULL) {
      switch(dynamic.d_tag) {
       case DT_PLTGOT:
	 info->got=(long)dynamic.d_un.d_ptr;
#ifdef FREEBSD
	/* by the power of greyskull... */
	if(!(info->got & 0xff000000)) 
		info->got+=(long)lm->l_addr; 
#endif	
	 break;
       case DT_STRTAB:
	 info->strtab=(long) dynamic.d_un.d_ptr; 
#ifdef FREEBSD
        if(!(info->strtab & 0xff000000))
                info->strtab+=(long)lm->l_addr;
#endif
	 break;
       case DT_STRSZ:
	 info->strsz=(unsigned int ) dynamic.d_un.d_ptr;
	 break;
	 // need to re-add DT_HASH case
      }
      daddr+=dsize;
      pRead(daddr, &dynamic, dsize);
   }
   return info;
}

size_t pRead(unsigned long src, void *dst, size_t sz) {
   int i;
   unsigned long word;
   for(i=0; i < sz; i=i+4) {
      word=ppeek(src+i);
      memcpy(dst+i, &word, 4);
   }
   /* memcpy(dst,(void *)src,sz); */
   return i;
}

void dump_symbols(Elf32_Addr dynamic, struct link_map *lm) {

   char symbinding[3]={'L', 'G', 'W'};
   char symtype[5]={'N', 'O', 'F', 'S', 'L'};
   int i;

   unsigned int nchain;
   Elf32_Addr symtab=get_dynamic_tag(dynamic,lm,DT_SYMTAB);
   Elf32_Sym syment;
   Elf32_Addr strtab=get_dynamic_tag(dynamic,lm,DT_STRTAB);
#ifdef FREEBSD
   /* are you pondering what im pondering, pinky? */
   if(!(symtab & 0xff000000))
	symtab+=(long)lm->l_addr;
   if(!(strtab & 0xff000000))
	strtab+=(long)lm->l_addr;
#endif
   //pRead( get_dynamic_tag(dynamic,lm,DT_STRTAB), strtab, get_dynamic_tag(dynamic,lm,DT_STRSZ));
	 
   
   fprintf(out,"\nSYMBOL TABLE\n");
   fprintf(out,"------------\n\n");

   while(1){	   
      get_symbol(symtab, &syment);   
      symtab+=sizeof(Elf32_Sym);
      /*
       *
       *  here i apply again heuristic teletubbie power:
       *
       *  as i don't know the lenght of the symtab, i continue dumping
       *  until the first st_name that doesn't seem to be an offset
       *  (fear big string tables...)
       *  
       */
      if(syment.st_name&0xff0000) {fprintf(out," -- SYMTAB end --\n"); goto end;}
      dump_symbol(&syment, strtab);
   }	
end:
   fprintf(out,"\n\n");
}

void pdetach(void){
   int err;
#ifdef FREEBSD
	#define ASCO 1 /* this remind me a .br friend o_O */
#else
	#define ASCO 0
#endif
	err = ptrace(PT_DETACH,pid,ASCO,0);
   if(err) {
      perror("pdettach");
      exit(-1);
   }
#ifdef FREEBSD
   kill(pid, SIGCONT);
#endif
}
/* asco function */
char *getString(unsigned long addr ) {
   long buf[PATH_MAX]; 		       /* .todo: change for max name sz */
   char *str;
   pRead(addr,buf,PATH_MAX);
   str = (char*)malloc(strlen((char*)buf)+1);
   strncpy(str, (char*)buf, strlen((char*)buf)+1);
   return str;
}
/* asco II function */
char *getStringB(unsigned long addr ) {
   char buf[PATH_MAX]; 	       
   char *str;
   unsigned int size=PATH_MAX,bufsize;
   pRead(addr-PATH_MAX,buf,PATH_MAX);
   size--;
   while( (size > 0) && ((buf[size] < 0x2F) || (buf[size] > 0x7A)) )
     size--;
   while( (size > 0) && (buf[size]!='\0') )
     size--;
   size++;
   bufsize=strlen(buf+size);
   fprintf(out, "size? %d\n", bufsize);
   str=(char *)malloc(bufsize+1);
   fprintf(out,"addr: %x - string addr: %x\n", addr, addr - (PATH_MAX-size));
   memcpy(str, buf+size, bufsize);
   str[bufsize]='\0';
   return str;
}
/* get String Address Backward */
Elf32_Addr getSAB(unsigned long addr ) {
#ifdef LINUX 
  char buf[PATH_MAX]; 	       
   unsigned int size=PATH_MAX; 
   pRead(addr-PATH_MAX,buf,PATH_MAX);
   size--;
   while( (size > 0) && ((buf[size] < 0x2F) || (buf[size] > 0x7A)) )
     size--;
   while( (size > 0) && (buf[size]!='\0') )
     size--;
   size++;
   return (addr - (PATH_MAX-size));
#elif FREEBSD
	Elf32_Addr wee;
 	pRead(addr-15, &wee, sizeof(long));
	pRead(wee, &wee, sizeof(long));	
	return wee;
#endif
}	
long ppeek(int addr){  
   return ptrace(PT_READ_I,pid, addr,0);
   /* check better */
}

pmemset(unsigned long start, unsigned long data, unsigned long len){
	unsigned long x;
	for(x=start;x<=start+len;x+=4)
		ptrace(PT_WRITE_I,pid,x,data);
}

void
write_data(unsigned long addr , void *vptr , unsigned long len)
{
	int i , count;
	long word;
	i = count = 0;

	while (count < len) {
		memcpy(&word , vptr+count , sizeof(word));
		//printf("write_data: writing 0x%x at 0x%x\n",word,addr+count);
		word = ptrace(PT_WRITE_I, pid ,addr+count , word);
		count +=4;
	}
}

void pdump(unsigned long start, unsigned long end){
	unsigned long x;
	printf("dumping process...\n");
	for(x=start;x<=end;x+=4){
		printf("0x%x : %x\n",x,ppeek(x));
	}
}


void pattach(void){

        int err;
        err = ptrace(PT_ATTACH,pid,0,0);
        if(err) fatal("ptattach: %s",strerror(errno));
}
void pcont(int signal) {
	int err;
	err=ptrace(PT_CONTINUE, pid, 1,0);
	if(err) fatal("pcontinue: %s", strerror(errno));
}
int pwaitpid(void)
{
        int err,status;

        err  = waitpid(pid,&status,0);
        if (err == -1) fatal("waitpid");
        return status;
}


void fatal(char *format, ...) {
   va_list ap;
   va_start(ap, format);
   vfprintf(stderr, format, ap);
   fflush(stderr);
   va_end(ap);
   pdetach();
   exit(-1);
}

void a_Warning(int type, char *format, ...) {
	char *warns[]={"low level warning", "med level warning","high level warning"};
	va_list ap;
   	va_start(ap, format);
	fprintf(out, "<%s> ", warns[type]); 
	vfprintf(out, format, ap);
	fflush(stderr);
	va_end(ap);
}

char *options(int option, char **lala, int amount) {
   if(option < amount)
     return lala[option];
     //fprintf(out, "%s",lala[option]);
   else
     return "*NONE*";
}

unsigned int get_ehdr(unsigned long base, Elf32_Ehdr *ehdr){
   if(base==0) return 0;
   pRead(base,ehdr,sizeof(Elf32_Ehdr));
   return 1;
}

unsigned int get_phdr(unsigned long base,size_t sz, Elf32_Phdr **phdr){
  
   *phdr = (Elf32_Phdr *)malloc(sz);
   if(base==0) return 0;
   pRead(base,*phdr,sz);
   return 1;
}

void dump_ehdr(Elf32_Ehdr ehdr){

   char *TYPE[]={"NONE", "REL", "EXEC", "DYN", "CORE"};
   char *MACHINE[]={
	"NONE", "M32", "SPARC", "386", "M6800",
     	"M8800", 0, "i80860", "mips3000", 0, "mips4000"};
   char *CLASS[]={"NONE", "32bits", "64bits"};
   char *DATA[]={"NONE", "LSB", "MSB"};

   fprintf(out,"\nELF HEADER\n");
   fprintf(out,"----------\n");
   fprintf(out,"  arquitecture:  %s (%s) flags 0x%08x: ", options(ehdr.e_machine, MACHINE, 11),options((int)ehdr.e_ident[EI_CLASS], CLASS, 3), ehdr.e_machine);
   fprintf(out, "%s,%s\n", options(ehdr.e_type, TYPE, 5),options(ehdr.e_ident[EI_DATA], DATA, 3));   
   fprintf(out,"  e_entry:       0x%x\n", ehdr.e_entry);
   fprintf(out,"  e_phoff:       0x%x\n",ehdr.e_phoff);
   fprintf(out,"  e_shoff:       0x%x\n",ehdr.e_shoff);
   fprintf(out,"  e_ehsize:      0x%x\n",ehdr.e_ehsize);
   fprintf(out,"  e_phentize:    0x%x\n",ehdr.e_phentsize);
   fprintf(out,"  e_phnum:       0x%x\n",ehdr.e_phnum);
   fprintf(out,"  e_shentsize:   0x%x\n",ehdr.e_shentsize);
   fprintf(out,"  e_shnum:       0x%x\n",ehdr.e_shnum);
   fprintf(out,"  e_shstrndx:    0x%x\n",ehdr.e_shstrndx);
   fprintf(out,"\n\n");
}

void dump_phdr(Elf32_Phdr *phdr, int e_phnum){

        int i;
   	char *TYPE[]={"NULL", "LOAD", "DYNAMIC", "INTERP", "NOTE", "SHLIB", "PHDR"};

        fprintf(out,"\nPROGRAM HEADER\n");
        fprintf(out,"--------------\n");
        for(i=0; i < e_phnum; i++){
      fprintf(out, "%8s    off 0x%08x vaddr 0x%08x paddr 0x%08x align 2 * %d\n", options(phdr[i].p_type, TYPE,7), phdr[i].p_offset, phdr[i].p_vaddr, phdr[i].p_paddr,phdr[i].p_align);
      fprintf(out, "         filesz 0x%08x memsz 0x%08x flags %c%c%c\n", phdr[i].p_filesz, phdr[i].p_memsz, ((phdr[i].p_flags & PF_R)?'r':'-'), ((phdr[i].p_flags & PF_W)?'w':'-'), ((phdr[i].p_flags & PF_X)?'x':'-') );
	        fprintf(out,"\n");
	}
}

unsigned long get_dynamic(Elf32_Phdr *phdr, int e_phnum){
        int i;
        for(i=0; i < e_phnum; i++)
        	if(phdr[i].p_type == PT_DYNAMIC) return phdr[i].p_vaddr;
        return 0;
}

void dump_reloc(Elf32_Addr reloc, unsigned int relsz, Elf32_Addr symtab, Elf32_Addr strtab){
	Elf32_Rel rentry;
	Elf32_Sym symbol;
	unsigned int count=0;
	char *name;
	char *REL[]={			/* from glibc-2.2.5 */
					/* Intel 80386 specific definitions.  */
		"R_386_NONE",		/* No reloc */
		"R_386_32",		/* Direct 32 bit  */
		"R_386_PC32",		/* PC relative 32 bit */
		"R_386_GOT32",		/* 32 bit GOT entry */
		"R_386_PLT32",		/* 32 bit PLT address */
		"R_386_COPY",		/* Copy symbol at runtime */
		"R_386_GLOB_DATA",	/* Create GOT entry */
		"R_386_JMP_SLOT",	/* Create PLT entry */
		"R_386_RELATIVE",	/* Adjust by program base */
		"R_386_GOTOFF", 	/* 32 bit offset to GOT */
		"R_386_GOTPC",		/* 32 bit PC relative offset to GOT */
		"R_386_NUM"};		/* Keep this the last entry.  */

        fprintf(out,"\nRELOCATION TABLE (DT_REL)\n");
        fprintf(out,"----------------\n");

        do {
                pRead(reloc,&rentry,sizeof(Elf32_Rel));

		if(count == relsz) fprintf(out,"\n\tstart of DT_JMPREL:\n\n");

		// you know about p0's advanced heuristics...
      		if(ELF32_R_SYM(rentry.r_info)&0xffff0000) {fprintf(out,"\t-- REL end --\n"); break;}

                reloc += sizeof(Elf32_Rel);
		count += sizeof(Elf32_Rel);
	
		get_symbol(ELF32_R_SYM(rentry.r_info)*sizeof(Elf32_Sym)+symtab,&symbol);
		name=(char *)getString(symbol.st_name+strtab);

                if(ELF32_R_TYPE(rentry.r_info) >=11 ){ 
                        fprintf(out,"\t0x%x   %19xh   0x%-4x  ->  %s\n",rentry.r_offset,ELF32_R_TYPE(rentry.r_info),ELF32_R_SYM(rentry.r_info),name);
                        continue;
                }
		else {
			fprintf(out,"\t0x%x   %20s   0x%-4x  ->  %s\n",rentry.r_offset,REL[ELF32_R_TYPE(rentry.r_info)],ELF32_R_SYM(rentry.r_info),name);
		}

		free(name);        	

        } while(1);
	fprintf(out,"\n\n");
	
}

void dump_dynamic(Elf32_Addr dynamic,Elf32_Addr strtab){
        Elf32_Dyn dentry;
        char *str;
        char *DT[]={
      		"DT_NULL",
      		"DT_NEEDED",
      		"DT_PLTRELSZ",
		"DT_PLTGOT",
	   	"DT_HASH",
	   	"DT_STRTAB",
		"DT_SYMTAB",
		"DT_RELA",
		"DT_RELASZ",
		"DT_RELAENT",
		"DT_STRSZ",
		"DT_SYMENT",
		"DT_INIT",
      		"DT_FINI",
		"DT_SONAME",
		"DT_RPATH",
		"DT_SYMBOLIC",
		"DT_REL",
		"DT_RELSZ",
		"DT_RELENT",
		"DT_PLTREL",
		"DT_DEBUG",
		"DT_TEXTREL",
		"DT_JMPREL",
		"DT_LOCPROC",
		"DT_HIPROC"};

        fprintf(out,"\n_DYNAMIC @ 0x%x\n",dynamic);
        fprintf(out,"--------\n");

        do {
                pRead(dynamic,&dentry,sizeof(Elf32_Dyn));
                dynamic += sizeof(Elf32_Dyn);
                if(dentry.d_tag>=25 || dentry.d_tag < 0){
                        fprintf(out,"%19xh -> 0x%x\n",dentry.d_tag,dentry.d_un.d_ptr);
                        continue;
                }
                if(dentry.d_tag==DT_NEEDED || dentry.d_tag==DT_SONAME){
			str=getString(strtab+dentry.d_un.d_ptr);
			fprintf(out,"%20s -> %s\n",DT[dentry.d_tag],str);
			free(str);
		}
		else
			fprintf(out,"%20s -> 0x%x\n",DT[dentry.d_tag],dentry.d_un.d_ptr);
        } while(dentry.d_tag != DT_NULL);
	fprintf(out,"\n\n");
}

unsigned long get_auxv_entry(Elf32_Addr auxv,unsigned int entry){

	unsigned long type = 0;
	unsigned long data = 0;
	
	while(1){
		type = ppeek(auxv);
		data = ppeek(auxv+4);
		if(type==entry) return data;
		if(!type) break;
		auxv+=8;
	}
	return 0;
}

unsigned long get_dynamic_tag(Elf32_Addr dynamic,struct link_map *lm,unsigned int tag){
        Elf32_Dyn dentry;
	unsigned long found=0;
        do {
        		pRead(dynamic,&dentry,sizeof(Elf32_Dyn));
            dynamic += sizeof(Elf32_Dyn);
            if (dentry.d_tag == tag){
					/* 
			 	 	 * next check is needed at least for DT_HASH
			 	 	 * any other check needs this ?
			 	 	 */ 
					// is this check ok?
 					if(dentry.d_tag == DT_HASH && lm && (long)lm->l_addr > dentry.d_un.d_ptr)
	   				/* loaded shared object's d_ptr =  offset */
	   				found =dentry.d_un.d_ptr+(long) lm->l_addr;
	 				else
	   				/* main object's d_ptr = absolute address */
						found = dentry.d_un.d_ptr;
					break;
				}
        } while(dentry.d_tag != DT_NULL);
	return found;
}

void dump_auxv(Elf32_Addr auxv){

/*
 * usr/src/linux/include/linux/elf.h
 * Symbolic values for the entries in the auxiliary table
 * put on the initial stack 
 */

//#define AT_NULL   0     /* end of vector */
//#define AT_IGNORE 1     /* entry should be ignored */
//#define AT_EXECFD 2     /* file descriptor of program */
//#define AT_PHDR   3     /* program headers for program */
//#define AT_PHENT  4     /* size of program header entry */
//#define AT_PHNUM  5     /* number of program headers */
//#define AT_PAGESZ 6     /* system page size */
//#define AT_BASE   7     /* base address of interpreter */
//#define AT_FLAGS  8     /* flags */
//#define AT_ENTRY  9     /* entry point of program */
//#define AT_NOTELF 10    /* program is not ELF */
//#define AT_UID    11    /* real uid */
//#define AT_EUID   12    /* effective uid */
//#define AT_GID    13    /* real gid */
//#define AT_EGID   14    /* effective gid */
//#define AT_PLATFORM 15  /* string identifying CPU for optimizations */
//#define AT_HWCAP  16    /* arch dependent hints at CPU capabilities */
//#define AT_CLKTCK 17    /* frequency at which times() increments */

/*
 * check out at /usr/src/linux/fs/binfmt_elf.c
 * 
 * static elf_addr_t *
 * create_elf_tables(char *p, 
 *                int argc, 
 *                int envc,
 *                struct elfhdr * exec,
 *                unsigned long load_addr,
 *                unsigned long load_bias,
 *                unsigned long interp_load_addr, 
 *                int ibcs)
 */

	int i=0;
	unsigned long type=0,data=0;
	char *AT[]={
		"AT_NULL","AT_IGNORE","AT_EXECFD","AT_PHDR","AT_PHENT","AT_PHNUM","AT_PAGESZ", 
		"AT_BASE","AT_FLAGS","AT_ENTRY","AT_NOTELF","AT_UID","AT_EUID","AT_GID",
		"AT_EGID","AT_PLATFORM","AT_HWCAP","AT_CLKTCK"};

	fprintf(out,"\nAUXV @ 0x%x\n",auxv);
	fprintf(out,"----\n");
	
	while(1){
		type = ppeek(auxv);
		data = ppeek(auxv+4);
		fprintf(out,"auxv[%2d] = %20s 0x%x\n",i++,AT[type],data);
		if(!type) break;
		auxv+=8;
	}
	fprintf(out,"\n");
}


/*
 * this must be improved...
 * we should be able to find everything using always the same STACK_START address
 */
Elf32_Addr get_auxv(Elf32_Addr stack_top){

#ifdef LINUX
   Elf32_Addr lastEnvStr;
   unsigned int zero;
   unsigned char aChar;

   // let's search last env ASCII str
   for(lastEnvStr=stack_top-4-2/*?*/,zero=2;zero;lastEnvStr--){
   	pReadChar(lastEnvStr,&aChar);
	//fprintf(out,"get_auxv() pReadChar() %c @ 0x%x\n",aChar,lastEnvStr);
   	if(!aChar) zero--;
   }
   lastEnvStr += 1+1;

   return searchWord(stack_top-4,0,lastEnvStr)+8;
#elif FREEBSD
	Elf32_Addr env;
	Elf32_Addr auxv;
	pRead(stack_top-7, &env, sizeof(Elf32_Addr));
	do {
		pRead(env, &auxv, sizeof(Elf32_Addr));
		env+=4;
	} while(auxv !=0x0);
	return env;
#endif
}

void pReadChar(unsigned long src, unsigned char *dst){
        unsigned char aux[4];
        pRead(src,aux,4);
        *dst = aux[0];
        //fprintf(out,"read %c @ 0x%x\n",aux[0],src);
}


/* less efficient code, searchs unaligned data... */
unsigned long
searchWord(unsigned long start, unsigned long stop, unsigned long iwantu){
	if(start<stop){
		while(start<=stop){
			if(iwantu == ppeek(start)) return start;
			//printf("searchWord -> %x@%x\n",ppeek(start),start);
			//start+=sizeof(start);
			start++;
		}
	} else {
		while(start>=stop){
			if(iwantu == ppeek(start)) return start;
			//printf("searchWord -> %x@%x\n",ppeek(start),start);
			//start-=sizeof(start);
			start--;
		}
	}
	return 0;
}

void dump_envp(Elf32_Addr envp){

	unsigned long str;
	fprintf(out,"\nENVP[] @ 0x%x\n",envp);
	fprintf(out,"------\n");
	for(str=envp;ppeek(str);str+=4)
		fprintf(out,"0x%x -> 0x%x -> %s\n",str,ppeek(str),getString(ppeek(str)));
	fprintf(out,"\n");
}

void dump_argv(Elf32_Addr argp){

	unsigned long str;

	fprintf(out,"\nARGV[] @ 0x%x\n",argp);
	fprintf(out,"------\n");
	for(str=argp;ppeek(str);str+=4)
		fprintf(out,"0x%x -> 0x%x -> %s\n",str,ppeek(str),getString(ppeek(str)));
	fprintf(out,"\n");
}

// mmm, dick sucking function (pls don't read it)
Elf32_Addr get_argv(Elf32_Addr argv_end){
	//while(ppeek(argv_end)&&0xf0000000) argv_end-=4;
	while(ppeek(argv_end)&0xf0000000) argv_end-=4;
	return argv_end+4;
}

unsigned long get_debug(Elf32_Addr address,struct r_debug *rd){
	if(address==0) return 0;
	return pRead(address,rd,sizeof(struct r_debug));
}

void dump_debug(struct r_debug *rd){

/*
 *
 * glibc-2.2.5:
 *
 * Rendezvous structure used by the run-time dynamic linker to communicate
 * details of shared object loading to the debugger.  If the executable's
 * dynamic section has a DT_DEBUG element, the run-time linker sets that
 * element's value to the address where this structure can be found.  
 *
 */
	fprintf(out,"\nDT_DEBUG \n",rd);
	fprintf(out,"--------\n\n");
	fprintf(out,"\tr_version          0x%x\n",rd->r_version);
	fprintf(out,"\tr_map              0x%x\n",rd->r_map);
	fprintf(out,"\tr_brk              0x%x\n",rd->r_brk);		// _dl_debug_state_internal()
	fprintf(out,"\n");
}

Elf32_Addr find_stack_top(void){

	Elf32_Addr stack=STACK_TOP;
	long r = 0;
	while(1){
		errno = 0;
		r = ppeek(stack--);
		if(r!=-1 || errno ==0) break;
	}
	return (Elf32_Addr)stack+4;
}

/* espero que dios me mande algo mejor... */
unsigned long search(unsigned long start, unsigned long stop, char *iwantu, unsigned long len) {
	unsigned long match;
	unsigned char buf[len];
	while(start <= stop) {
		match=0;
		while(match <= len) {
			pReadChar(start +match, &buf[match]);
			if (buf[match]!=iwantu[match])
				break;
			if (match==len-1) 
				return start;
			match++;
		}
		((unsigned char *)start)++;	
	}
	return 0;
}
unsigned long
search_old(unsigned long start, unsigned long stop, char *iwantu, unsigned long len){

	unsigned char buf[len];
	unsigned long match;
	unsigned char c;
	
	// busca en ambos sentidos...
	if(start<stop){
		while(start<=stop){
			match = 0;
			while(match<=len){
				pReadChar(start+match,&buf[match]);
				if(memcmp(buf,iwantu,match)) break;
				else if(match==len) return start;
				else match++;
			}
			((unsigned char*)start)++;
		}
	}
	else {
		return 0;
		while(start>=stop){
			match = 0;
			while(match<=len){
				pReadChar(start+match,&buf[match]);
				if(memcmp(buf,iwantu,match)) break;
				else if(match==len) return start;
				else match++;
			}
		((unsigned char*)start)--;
		}
	}
	return 0;
}

// start <= stop
void search_elf(Elf32_Addr start,Elf32_Addr stop){
	
	Elf32_Addr found;
	Elf32_Ehdr ehdr = {0};
	char elfmag[4]={ELFMAG0,ELFMAG1,ELFMAG2,ELFMAG3};

	fprintf(out,"\nsearching ELFMAG between 0x%x and 0x%x\n",start,stop);	
	
	for(found = start;;found++){
		found = search(found,stop,elfmag,sizeof(elfmag));
		if(!found) break;
		else{  
			fprintf(out,"\tfound ELFMAG at 0x%x\n",found);
			get_ehdr(found,&ehdr);
			dump_ehdr(ehdr);
		}
	}
}

struct _Elf_hash *get_hash(Elf32_Addr dt_hash, Elf32_Addr symtab, Elf32_Addr strtab) {
	struct _Elf_hash *hachis=(struct _Elf_hash *)malloc(sizeof(struct _Elf_hash));
	char *ptr;
	/*    hash table illustrated
	 *    [  nbucket  ]
	 *    [  nchain   ]
	 *    [           ] <- buckets[nbucket *sz]
	 *    [   ...     ]
	 *    [           ] <- nchain[nbucket*sz]
	 *    [   ...     ]
	 */
	int sz=sizeof(Elf32_Addr);
	hachis->symtab=symtab;
	hachis->strtab=strtab;
	hachis->nbucket=ppeek(dt_hash);
	hachis->nchain=ppeek(dt_hash+sz); 
	hachis->bucket=(Elf32_Addr *)malloc(hachis->nbucket*sz);
	hachis->chain=(Elf32_Addr *)malloc(hachis->nchain*sz);
	pRead(dt_hash+sz*2, hachis->bucket, hachis->nbucket*sz);
	pRead(dt_hash+sz*2+hachis->nbucket*sz, hachis->chain, hachis->nchain*sz);

	return hachis;
}
int search_by_hash(struct _Elf_hash *hachis, char *find, int show) {
	unsigned int hash=_dl_elf_hash (find), sz=strlen(find);
	long ndx;
	char *symname;
	Elf32_Sym symbol;
	
	for(ndx=hachis->bucket[ hash % hachis->nbucket]; 
			ndx != STN_UNDEF; 
			ndx= hachis->chain[ndx]) {
		get_symbol(sizeof(Elf32_Sym) *ndx + hachis->symtab, &symbol);
		if(symbol.st_name==0)
			continue;
		symname=(char *)getString(hachis->strtab + symbol.st_name);
		if(!strncmp(symname, find, sz)) {
			if(!show) {
				free(symname);
				return ( sizeof(Elf32_Sym)* ndx +hachis->symtab);
			} else {
				fprintf(out, "Found: ");
				dump_symbol(&symbol, hachis->strtab);
			}
		}
		free(symname);
	}
	return 0;
}
int dump_hsymbol(struct _Elf_hash *hachis) {
	unsigned long h;	
	char *name;
	int i;
	Elf32_Sym symbol;
	long ndx,ndz;
	for(i=0; i < hachis->nbucket; i++) {
		for(ndx=hachis->bucket[i]; ndx;ndx=hachis->chain[ndx]) {
		get_symbol(sizeof(Elf32_Sym)*ndx+hachis->symtab, &symbol);
		if(!symbol.st_name || symbol.st_name&0xff0000)
		break;
		  dump_symbol(&symbol, hachis->strtab);
		}
	}		
}
void dump_symbol(Elf32_Sym *symbol, Elf32_Addr strtab) {
	char symbinding[3]={'L','G', 'W'};
	char symtype[5]={'N', 'O', 'F', 'S', 'L'};
	char *name;
	fprintf(out, "   %08x", symbol->st_value);
	fprintf(out, " %c", optionc( symbinding, ELF32_ST_BIND(symbol->st_info),3));
	fprintf(out, " %c", optionc(symtype, ELF32_ST_TYPE(symbol->st_info), 5));
	fprintf(out, " %08x", symbol->st_size);
	name=(char *)getString(symbol->st_name+ strtab);
	fprintf(out, " %s\n", name);
	free(name);        	
}
char optionc(char *array, int cual, int amount) {
	if (cual >= amount || cual <0) 
		return '*';	
	return array[cual];
}
void free_hash(struct _Elf_hash *hachis) {
	free(hachis->chain);
	free(hachis->bucket);
	free(hachis);		
}
void get_symbol(Elf32_Addr addr, Elf32_Sym *symbol) {
	pRead(addr, symbol, sizeof(Elf32_Sym));
}
unsigned long elf_hash(const unsigned char *name) {
		unsigned long h=0, g;
		while(*name) {
			h=(h <<4) + *name++;
			if (g=h & 0xf0000000)
				h^= g >> 24;
			h&=~g;
		}
		return h;
}

void dump_linkmap(struct link_map *l) {
	fprintf(out,"\nlink_map:\n");
        fprintf(out, "\tbase_addr   dynamic     previous    next        name\n");
	fprintf(out, "\t0x%08x", l->l_addr);
	fprintf(out, "  0x%08x", l->l_ld);
	fprintf(out, "  0x%08x", l->l_prev);
	fprintf(out, "  0x%08x", l->l_next);
	fprintf(out, "  %s\n", getString((long) l->l_name));
	fprintf(out,"\n");
}

void dump_linkmap_local(struct link_map *l) {
	fprintf(out,"\nlink_map @ 0x%x:\n",l);
        fprintf(out, "\tbase_addr   dynamic     previous    next        name\n");
	fprintf(out, "\t0x%08x", l->l_addr);
	fprintf(out, "  0x%08x", l->l_ld);
	fprintf(out, "  0x%08x", l->l_prev);
	fprintf(out, "  0x%08x", l->l_next);
	fprintf(out, "  %s\n", l->l_name);
	fprintf(out,"\n");
}
int check_PTLoad_P(Elf32_Phdr *text, Elf32_Phdr *data, Elf32_Ehdr *ehdr) {
	/* Dont EVEN try to ask me what this align do, because i dunno either jejjee */
	/* just jocking, some simple padding... maybe there is a nicer way to do it  */
	Elf32_Addr text_ptr= (text->p_vaddr+text->p_memsz) + (data->p_vaddr - (text->p_vaddr + text->p_memsz) &~ DEFAULT_ALIGN);
	Elf32_Addr temp_ptr;
	long from_data, from_text;
	char temp;
	int i, condition=0;
	
	/******** FIRST PADDING ********
	 * We are looking on the first padding between txt->vaddr + txt->memsz 
	 * and text_ptr (look over there). By default this MUST be zero, unless something weird happends
	 * */
	temp_ptr= text->p_vaddr + text->p_memsz;
	from_text=text_ptr - temp_ptr; // temporary size
#ifdef DEBUG
	fprintf(out, "DEBUG> First Padding start: 0x%x size: %d\n", temp_ptr, from_text);
#endif
	for(i=0; i < from_text; i++) {
		pReadChar(temp_ptr, &temp);
		if(temp) {
			a_Warning(WARN_MEDLEVEL, "Error on the first txt Padding, it has to be zero (%x)\n\tDisassemble with: procshow -D -x 0x%x -y 0x%x -Z %d\n", temp&0xff, temp_ptr, (text->p_vaddr + text->p_memsz )+from_text, pid);
			condition++;
			break;
		}
		temp_ptr++;
	}
	/******** SECOND PADDING ********
	 * We compare the first padding final and the start of the data
	 * with the beggining of the data. (hope u understand, if not, send me an email)
	 */
	temp_ptr=data->p_vaddr;
#ifdef FREEBSD
	#define PLUS sizeof(long)
	/* the first 4 bytes, always change */
	text_ptr+=sizeof(long);
	temp_ptr+=sizeof(long);
#else
	#define PLUS 0
#endif
	for(i=0; i < ((data->p_memsz & ~DEFAULT_ALIGN)-PLUS)/4  ; i++) {
		pRead(text_ptr, &from_text, sizeof(long ));
		pRead(temp_ptr, &from_data, sizeof(long));
		if( from_text != from_data) {
			a_Warning(WARN_LOWLEVEL, "Second padding (text) differs on byte: %d (padding percentage: %d%%)\n\tDisassemble it: procshow -D -x 0x%x -y 0x%x -Z %d\n", i*4, ((i*4) * 100) / ((data->p_memsz & ~DEFAULT_ALIGN)-PLUS), text_ptr - (i*4), text_ptr -(i*4) +((data->p_memsz & ~DEFAULT_ALIGN)) , pid);
			break;
		}
		text_ptr+=sizeof(long);
		temp_ptr+=sizeof(long);
	}
#ifdef DEBUG
	fprintf(out, "DEBUG> Padding: byte cmp = %x size= %x percentage: %d%%\n", i*4, data->p_memsz & ~DEFAULT_ALIGN, ((i*4) * 100) / (data->p_memsz & ~DEFAULT_ALIGN) );
#endif
      /*  THIRD PADDING
       *  The REAL address of the begging of the data Padding (p_vaddr &~0xfff) with the begging of the text page
       */
	text_ptr=text->p_vaddr;
	temp_ptr=data->p_vaddr & ~(DEFAULT_ALIGN-1);
	for(i=0; i < (data->p_vaddr - (data->p_vaddr & ~(DEFAULT_ALIGN-1)))/4 ; i++) {
		pRead(text_ptr, &from_text, sizeof(long ));
		pRead(temp_ptr, &from_data, sizeof(long));
		if( from_text != from_data) {
			a_Warning(WARN_MEDLEVEL, "Third Padding (data) differs on byte: %d (padding percentage: %d%%)\n\tDissasemble with: procshow -D -x 0x%x -y 0x%x -Z %d\n",  i*4, ((i*4) * 100)/  (data->p_vaddr - (data->p_vaddr & ~(DEFAULT_ALIGN-1))), temp_ptr+ (i*4), temp_ptr+ (data->p_vaddr - (data->p_vaddr & ~(DEFAULT_ALIGN-1))), pid);
			condition++;
			break;
		}
		text_ptr+=sizeof(long);
		temp_ptr+=sizeof(long);
	}
	return condition;
}
int get_PTLoad(Elf32_Phdr *phdr, unsigned int phnum, long **ret_phdr) {
	int i;
	int pete_num=0;
	*ret_phdr=calloc(sizeof(long *), phnum);
	for(i=0; i < phnum; i++) {
		if (phdr[i].p_type==PT_LOAD) {
			//if(pete_num>1) 
			//	*ret_phdr=realloc(*ret_phdr, sizeof(Elf32_Phdr *) * pete_num+1);
			*(*ret_phdr+pete_num)=(long ) &(phdr[i]);
			pete_num++;
		}
	}
	return pete_num;
}

int check_PTLoad(long *array, int pt_num, Elf32_Ehdr *ehdr) {
	int i;
	Elf32_Phdr *phdr;
	int condition=0;
	if(pt_num !=2) {
		a_Warning(WARN_HIGLEVEL, "Anormal amount of load sections: %d\n", pt_num);
		condition++;
	}
	for(i=0; i < pt_num; i++) {
		/* Check Aligment */
		phdr=(Elf32_Phdr *) array[i];
		if( phdr->p_align!= DEFAULT_ALIGN) {
			a_Warning(WARN_HIGLEVEL, "Aligment differs from default (0x1000):\n\t offset: 0x%08x vaddr: 0x%08x ->align: 0x%08x<-\n", phdr->p_offset, phdr->p_vaddr, phdr->p_align);
			condition++;
		}
		if( phdr->p_flags & !(PF_W | PF_X | PF_R)) {
			a_Warning(WARN_LOWLEVEL, "Found some weird flags\n\t offset: 0x%08x vaddr: 0x%08x -> flags: %c%c%c <-\n", phdr->p_offset, phdr->p_vaddr, ((phdr->p_flags & PF_R)?'r':'-'), ((phdr->p_flags & PF_W)?'w':'-'), ((phdr->p_flags & PF_X)?'x':'-'));
		        condition++;
		}
	}
	/* Ok, i know, i have to put all these in one flags_check function... (TODO) */
	 
	/*  .text  */
	phdr=(Elf32_Phdr *)array[0];
	
	/* checking if .text is writable */
	if( phdr->p_flags & PF_W) {
		a_Warning(WARN_HIGLEVEL, ".text (PT_LOAD[0]) area is writable\n");
		condition++;
	}

	/* if( !((phdr->p_flags & PF_X) && (phdr->p_flags & PF_R)) ) { */

	/* check default flags */
	if( (phdr->p_flags & (PF_W|PF_R|PF_X)) != (PF_X | PF_R)) {	
		a_Warning(WARN_MEDLEVEL, " .text (PT_LOAD[0]) hadn't default flags (R&W)\n\t offset: 0x%08x vaddr: 0x%08x -> flags: %c%c%c <-\n", phdr->p_offset, phdr->p_vaddr, ((phdr->p_flags & PF_R)?'r':'-'), ((phdr->p_flags & PF_W)?'w':'-'), ((phdr->p_flags & PF_X)?'x':'-'));
		condition++;
        }
	if( phdr->p_filesz != phdr->p_memsz) {
		a_Warning(WARN_MEDLEVEL, " .text (PT_LOAD[0]) had different sizes\n\tvaddr: 0x%08x -> memsz: %08x filesz: %08x <-\n", phdr->p_vaddr, phdr->p_memsz, phdr->p_filesz);
		condition++;
	}
	/*  .data  */
	phdr=(Elf32_Phdr *)array[1];
	
	/* checking if it is executable */
	if( phdr->p_flags & PF_X) {
		a_Warning(WARN_HIGLEVEL, ".data (PT_LOAD[1]) area is executable\n");
		condition++;
	}
	
	/* if( !((phdr->p_flags & PF_W) && (phdr->p_flags & PF_R)) ) { */
	
	/* check default flags */
	if( (phdr->p_flags &(PF_W|PF_R|PF_X)) != (PF_W | PF_R) ) { 
		a_Warning(WARN_MEDLEVEL, " .data (PT_LOAD[1]) hadn't default flags (R&W)\n\t offset: 0x%08x vaddr: 0x%08x -> flags: %c%c%c <-\n", phdr->p_offset, phdr->p_vaddr, ((phdr->p_flags & PF_R)?'r':'-'), ((phdr->p_flags & PF_W)?'w':'-'), ((phdr->p_flags & PF_X)?'x':'-'));
		condition++;
	}
	if( phdr->p_filesz > phdr->p_memsz) {
		a_Warning(WARN_LOWLEVEL, ".data (PT_LOAD[1] had filesz bigger than memsz\n\tvaddr: 0x%08x -> memsz: %08x filesz: %08x <-\n", phdr->p_vaddr, phdr->p_memsz, phdr->p_filesz);
		condition++;
	}
	condition+=check_PTLoad_P((Elf32_Phdr *)array[0], (Elf32_Phdr *) array[1], ehdr);

	return condition;
}
int check_Ehdr(long *ptload, int pt_num, Elf32_Ehdr *ehdr) {	
	Elf32_Phdr *phdr;
	int condition=0,i;
	/* mnnnn.. i will not check on EVERY member of ehdr, unless u want to do it */
	if( ehdr->e_phoff != sizeof(Elf32_Ehdr)) {
		a_Warning(WARN_MEDLEVEL, "The phdr its not at the end of Ehdr (off: 0x%x)\n", ehdr->e_phoff);
		condition++;
	}
	if( ehdr->e_phentsize != sizeof(Elf32_Phdr)) {
		a_Warning(WARN_MEDLEVEL, "The ehdr->phentsize (size of Phdr) its not the oficial (size: %x)\n", ehdr->e_phentsize);
		condition++;
	}
	for(i=0; i < pt_num; i++) {
		phdr=(Elf32_Phdr *) ptload[i];
		if(ehdr->e_entry > phdr->p_vaddr && ehdr->e_entry < phdr->p_vaddr+phdr->p_memsz) {
#ifdef DEBUG
			fprintf(out, "DEBUG> Found elf entry on PHDR %d vaddr: 0x%x\n", i+1, phdr->p_vaddr);
#endif
			if(i != 0) {
				a_Warning(WARN_HIGLEVEL, "elf entry found outside .text area (entry 0x%x)\n\tfound on phdr %d v_addr: 0x%x\n", ehdr->e_entry, i+1, phdr->p_vaddr);
				condition++;
			}
			break;
		}
	}
	if(pt_num==i) {
		a_Warning(WARN_HIGLEVEL, "elf entry found outside our elf object (0x%x)\n", ehdr->e_entry);
		condition++;
	}
	return condition;
}
/* 
 * analizeME:
 * 	yeah, you know.. we all have to take care of our mental health 
 * 	This function looks for possible virii infection and warn about it 
 */
void analizeME(Elf32_Addr main_base, Elf32_Ehdr *ehdr, Elf32_Phdr *phdr, Elf32_Addr dynamic, int so) {
	int conditions=0,temp=0;
	long *ptload;

	/* Check PT_LOAD */
	temp=get_PTLoad(phdr, ehdr->e_phnum, &ptload);
#ifdef DEBUG
	fprintf(out, "DEBUG: PT_LOAD detected %d\n", temp);
#endif
	conditions+=check_PTLoad(ptload, temp, ehdr);
	conditions+=check_Ehdr(ptload, temp, ehdr);	
	fprintf(out, "-= Weird conditions founded: %d =-\n", conditions);
}
void hexdump(Elf32_Addr start, Elf32_Addr end) {
	int i,idx;
	char buf[16];
	long word;
	while(start < end) {
		idx=0;
		fprintf(out, "0x%08x: ", start);
		for (i=0; i < 4; i++) {
			pRead(start, &word, sizeof(long));
			fprintf(out, "%08x    ", word);
			//printf("(%x -%c)", (word>>12 & 0xff), (word>>12)& 0xff);
			buf[idx++]=  ( (word)& 0xff);
			buf[idx++]=  ( (word>>8 )& 0xff);
			buf[idx++]=  ( (word>>16 )& 0xff);
			buf[idx++]=  ( (word>> 24)& 0xff);
			start+=4;
		}
		for(i=0; i < 16; i++) 
			fprintf(out, "%c", (buf[i]> 0x1f && buf[i] < 0x7f) ? buf[i] : '.');
		fprintf(out, "\n");
	}
}
void strings(Elf32_Addr start, Elf32_Addr end) {
	int sz=end-start,i,match=0;
	char *ptr=0x0, *buf=(char *)malloc(sz);
	pRead(start, buf, sz);
	fprintf(out, "strings\n=======\n");
	for(i=0 ; i < sz; i++) {
		if(buf[i] >=0x20 && buf[i] <= 0x7E) {
			if(!ptr) 
				ptr=(char *)buf+i;
			match++;
		} else if(match > 3) {
			buf[i]='\0';
			fprintf(out, "0x%x: %s\n", start + (ptr-buf), ptr);
			match=0;
			ptr=0;
		} else 
			match=0;
	}
	free(buf);
}
void dump2file(char *file, Elf32_Addr map_start) {
	Elf32_Ehdr ehdr;
	Elf32_Phdr *phdr;
	int i, sz;
	FILE *fp;
	char *buf;
	fp=fopen(file, "w");
	
	get_ehdr(map_start, &ehdr);
	get_phdr(map_start + ehdr.e_phoff, ehdr.e_phentsize * ehdr.e_phnum, &phdr);
	for(i=0; i< ehdr.e_phnum; i++) {
		if (phdr[i].p_type!=PT_LOAD) continue;
		sz=phdr[i].p_filesz + (0x1000-1) &~(0x1000-1) ;
		buf=(char *)malloc(sz);
		pRead(phdr[i].p_vaddr, (char *)buf, sz);
		fwrite(buf, sizeof(char), sz, fp);
		free(buf);

	}
}
/*
 * got== plt address
 */
int is_plt(unsigned long *plt, Elf32_Addr begin, Elf32_Addr end, Elf32_Addr got, Elf32_Addr got_addr) {
	unsigned long push;
	long shamp;
	/* look for opcodes:
	 *    -  jmp *(0x25ff)
	 *    -  push (0x68)   
	 *    -  jmp  (0xe9)
	 *    */
	if( (plt[0] & 0x25ff) && ((plt[1]>>16) & 0x68) && ((plt[3] >> 24) & 0xe9) ) {
		
             /* check for jmp *GOT_ADDR */ 
		*((char *)&push)   = (plt[0]>>16) & 0xff;
		*((char *)&push+1) = (plt[0]>>24) & 0xff;
		*((char *)&push +2)= (plt[1])     & 0xff;
		*((char *)&push +3)= (plt[1]>>8)  & 0xff;
	     if(push != got_addr ) {
	     	fprintf(out, "the plt entry doesn't correspond to the got entry: (jmp *0x%08x instead of jmp *0x%08x)\n", push, got_addr);
	     }
	    /* check for push $RELOCATION_NUMBER */
		*((char *)&push)   = (plt[1] >> 24) & 0xff;
		*((char *)&push+1) = (plt[2])       & 0xff;
		*((char *)&push +2)= (plt[2] >> 8)  & 0xff;
		*((char *)&push +3)= (plt[2] >> 16) & 0xff;
		if(push!=end-begin) {
			fprintf(out, "push $0x%x doesnt match with current relocation entry 0x%x\n");
		}
	    /* check for jmp $NEG_OFFSET_TO_PLT0 */
		shamp=plt[3];
		/* first entry */
		if(push==0x0) push=0x4;
		if( ( got - (push/0x8)*0x10 - 0x16) != (got+ shamp + 0xa) ) {
			fprintf(out, "the resolution jmp (0x%08x) doesnt jump to first plt_entry (0x%08x)\n", (got-(0x10 * push/8) - 0x16),  (got + shamp+0xa) );
		}
	}
}

unsigned int check_got(struct link_map *lm2, Elf32_Ehdr *ehdr, Elf32_Addr base) {
	Elf32_Addr jmpidx,jmprel=get_dynamic_tag((Elf32_Addr) lm2->l_ld, lm2,  DT_JMPREL),got, found;
	Elf32_Addr symtab=get_dynamic_tag((Elf32_Addr) lm2->l_ld, lm2, DT_SYMTAB);
	Elf32_Addr strtab=get_dynamic_tag((Elf32_Addr) lm2->l_ld, lm2, DT_STRTAB);
	Elf32_Addr strtab_l;
	unsigned int jmpsz=get_dynamic_tag((Elf32_Addr) lm2->l_ld, lm2,  DT_PLTRELSZ);
	unsigned long plt_entry[4];
	Elf32_Rel rentry;
	Elf32_Sym symbol;
	struct link_map *lm=malloc(sizeof(struct link_map));
	char *symname;
	Elf32_Phdr *phdr, *idx;
	struct _Elf_hash *hachis;
	get_phdr(base + ehdr->e_phoff, ehdr->e_phentsize * ehdr->e_phnum, &phdr);
	idx=phdr;
	while(idx < phdr+ ehdr->e_phentsize * ehdr->e_phnum) {
		if((idx->p_flags & (PF_X | PF_R)) & idx->p_type==PT_LOAD)
			break;
		idx++;
	}
	if(idx==phdr+ehdr->e_phentsize * ehdr->e_phnum) {
		fprintf(out, "No .text area found\n");
		return 0;
	}
	jmpidx=jmprel;
	while(jmpidx < (jmprel + jmpsz) ) {
		pRead(jmpidx, &rentry, sizeof(Elf32_Rel));
		if(ELF32_R_TYPE(rentry.r_info) != R_386_JMP_SLOT) {
			fprintf(out, "something weird is going on, a strange relocation (0x%x) has been found at 0x%08x\n", ELF32_R_TYPE(rentry.r_info), jmpidx);
		}
		pRead(rentry.r_offset, &got, sizeof(Elf32_Addr));
		if( (got > idx->p_vaddr) && (got <= idx->p_vaddr + idx->p_filesz)) {
		/* not resolved address (lazy binding) */
			/* we read got minus 6, in order to read the entire plt entry */
			pRead(got-6, &plt_entry, sizeof(unsigned long) * 4);
			/* lets have some bobbies heuristic */
			is_plt(plt_entry, jmprel, jmpidx, got, rentry.r_offset);
		} else {
			/* already resolved, lets resolved it so we can compare */
			get_symbol(symtab + ELF32_R_SYM(rentry.r_info) * sizeof(Elf32_Sym), &symbol);
			symname=(char *)getString(strtab + symbol.st_name);
			memcpy(lm, lm2, sizeof(struct link_map));
			
			do {
				pRead((long) lm->l_next, (struct link_map *)lm, sizeof(struct link_map));
				hachis=(struct _Elf_hash *) get_hash(get_dynamic_tag( (Elf32_Addr)lm->l_ld, lm, DT_HASH), get_dynamic_tag((Elf32_Addr) lm->l_ld, lm, DT_SYMTAB),  get_dynamic_tag((Elf32_Addr) lm->l_ld, lm, DT_STRTAB));
				
				found=search_by_hash(hachis, symname, 0);
				if(found) {
					get_symbol(found, &symbol);
					if(!symbol.st_value)
						continue;
					if( got != (Elf32_Addr)(symbol.st_value + lm->l_addr) ) {
						fprintf(out, "strange resolution in %s (0x%08x) it has to be: 0x%08x - possible backdoor or virus\n", symname, got, symbol.st_value + lm->l_addr);
						
						fprintf(out, "[lib 0x%08x]",lm->l_addr); 
						dump_symbol(&symbol, get_dynamic_tag((Elf32_Addr) lm->l_ld, lm, DT_STRTAB));
					}
#ifdef DEBUG
					else {
						fprintf(out, "cool (%s -> 0x%08x)\n", symname, got);
					}
#endif
					break;
				}
				if(lm->l_next==NULL) break;
				
			} while(1);
		}
		jmpidx+=sizeof(Elf32_Rel);
	}
}

